 # coding: utf-8

from kivy.storage.jsonstore import JsonStore
from kivymd.uix.screen import MDScreen
from kivymd.uix.menu import MDDropdownMenu
import webbrowser


from assets.env import *


import warnings
warnings.showwarning = print


class AboutScreen(MDScreen):
    def __init__(self, **kwargs):
        super(AboutScreen, self).__init__(**kwargs)

        self.hamburger_menu_items = [
            {
                "text": 'Dashboard',
                "on_release": lambda *args: self.redirect_screen('dashboard'),
            },
            {
                "text": 'Setup a new device',
                "on_release": lambda *args: self.redirect_screen('setup'),
            },
            {
                "text": 'Add existing local device',
                "on_release": lambda *args: self.redirect_screen('local_add'),
            },
            {
                "text": 'Manual Update',
                "on_release": lambda *args: self.redirect_screen('update'),
            },
            {
                "text": 'Switch Dark/Light Mode',
                "on_release": lambda *args: self.change_display_mode(),
            },
            {
                "text": 'About',
                "on_release": lambda *args: self.redirect_screen('about'),
            },
        ]
        
        self.settings_store = JsonStore(data_path+'settings.json')
        self.local_store = JsonStore(data_path+'locals.json')
        self.shadow_store = JsonStore(data_path+'shadows.json')
        self.cookie_jar = JsonStore(data_path+'cookies.json')
        self.user_store = JsonStore(data_path+'user.json')

        self.hamburger_menu = MDDropdownMenu(
            caller=self.ids.hamburger_button,
            items=self.hamburger_menu_items,
        )

    def change_display_mode(self):
        self.theme_cls.theme_style = (
            "Dark" if self.theme_cls.theme_style == "Light" else "Light"
        )
        self.settings_store.put('theme', value=self.theme_cls.theme_style)


    def redirect_screen(self, screen = 'dashboard'):
        self.hamburger_menu.dismiss()
        self.manager.current = screen

    def open_license(self):
        webbrowser.open('https://www.gnu.org/licenses/agpl-3.0.en.html#license-text')